#!/usr/bin/perl

use strict;
use warnings;

BEGIN {
    if ($0 =~ m|^(.*)/[^/]+$|) {
        push(@INC, $1);
    }
}

use SOAP::Lite +trace => 'debug';
use MIME::Base64;
use HPSMSOAP;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my %argument = ();
foreach my $a (@ARGV) {
    if ($a =~ s/^([^=]+)=//) {
        $argument{$1} = $a;
    } else {
        die "invalid argument [$a]\n";
    }
}
my @required = qw(Contact Title Description Impact Urgency);
my @missing = ();
my $misscount = 0;
foreach my $r (@required) {
    if (! exists $argument{$r}) {
        $misscount += 1;
        push(@missing, $r);
    }
}
#die "$misscount required args missing:\n\t" . join(' ', sort(@missing)) . "\n"
#    if ($misscount);
$argument{'Category'} = 'incident';

my @xargs = ();
foreach my $k (keys %argument) {
    push(@xargs, SOAP::Data->name($k => $argument{$k}));
}
my $x = SOAP::Data->value(@xargs);

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/ServiceDesk.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"AddEscalateToIncident"'; } );

my $keys = SOAP::Data->name('keys' => '')->type('');
my $instance = SOAP::Data->name('instance' => \$x)->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call('AddEscalateToIncidentInteraction', $model);

soapfault($som);
soapstatus($som);
soapdata($som, '//AddEscalateToIncidentInteractionResponse/messages', 1);
soapdata($som, '//AddEscalateToIncidentInteractionResponse/model', 0);
